define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'tt_code/index' + location.search,
                    add_url: 'tt_code/add',
                    edit_url: 'tt_code/edit',
                    del_url: 'tt_code/del',
                    multi_url: 'tt_code/multi',
                    import_url: 'tt_code/import',
                    table: 'tt_code',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                // 搜索按钮框展开
                searchFormVisible: true,
                // 隐藏搜索按钮
                showSearch: false,
                //隐藏搜索框
                search:false,
                //隐藏切换按钮
                showToggle: false,
                //隐藏列按钮
                showColumns: false,
                //隐藏导出按钮
                showExport: false,
                columns: [
                    [
                        // {checkbox: true},
                        {field: 'id', title: __('Id'), operate:false},
                        {field: 'code', title: __('Code'), operate:'LIKE'},
                        {field: 'user_id', title: __('User_id'), searchList: $.getJSON('tt_code/admin_user')},
                        {field: 'update_time', title: __('Update_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'status', title: __('Status'), searchList: {"0":__('Status 0'),"1":__('Status 1')}, formatter: Table.api.formatter.status},
                        // {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});